/**
 * Created by JP on 06.12.2014.
 */
//todo wenn schneemann unten ankommt dann getweent blenden nicht hart alpha setzen (aber immer den selben tween wieder aufrufen, damit nicht 2 laufen)
var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
//todo irgendwas ans ziel stellen -> entschieden, eigene gruppe und darin hüpfende schneemänner
//todo keine unendliche flugweite für die bullets (tower range statt dessen! -> distance owner tower +10% -> kill())
//todo vllt nen slow tower (kosten 100 oso)
//todo vllt andere creeps?
var Gameplay = (function (_super) {
    __extends(Gameplay, _super);
    function Gameplay() {
        _super.apply(this, arguments);
        this.waypoints = [{ x: 247, y: 123 }, { x: 240, y: 478 }, { x: 822, y: 485 }, { x: 821, y: 705 }, { x: 95, y: 700 }];
        this.level = 999;
        this.wasUp = true;
        this.selectedTower = null;
        this.buildTower = false;
        this.money = 50;
        this.displayMoney = 0;
        this.keyWasUp = true;
    }
    Gameplay.setupText = function (text, centerInfoText) {
        text.font = "Arial Black";
        text.fontWeight = "bold";
        if (centerInfoText) {
            text.fontSize = 30;
            text.strokeThickness = 10;
            text.stroke = "#FF2233";
            text.fill = "#22FF33";
            text.align = "center";
            text.anchor.set(0.5, 0.5);
        }
        else {
            text.fontSize = 22;
            text.strokeThickness = 4;
            text.stroke = "#000000";
            text.fill = "#FFFFFF";
        }
    };
    Gameplay.prototype.create = function () {
        var level = this.game.add.sprite(0, 0, "levelgreen");
        this.deathOverlay = this.game.add.sprite(0, 0, "level");
        this.deathOverlay.alpha = 0;
        this.creepGroup = this.game.add.group();
        this.winnerGroup = this.game.add.group();
        this.towerGroup = this.game.add.group();
        this.bulletGroup = this.game.add.group();
        this.stuffGroup = this.game.add.group();
        //deko für den bereich rechts)
        this.game.add.sprite(1024, 0, "deco");
        this.buttonGroup = this.game.add.group();
        level.alpha = 0;
        var tween = this.game.add.tween(level).to({ alpha: 1 }, 500, Phaser.Easing.Linear.None, true);
        tween.onComplete.add(function () {
            this.reset();
        }.bind(this));
        this.deathText = this.game.add.text(512, 350, "Christmas has come early this year...\nYou lose!", "");
        Gameplay.setupText(this.deathText, true);
        this.deathText.alpha = 0.7;
        this.deathText.visible = false;
        this.game.add.tween(this.deathText.scale).to({
            x: 1.2,
            y: 1.2
        }, 1200, Phaser.Easing.Linear.None, true, 0, -1, true);
        this.infoText = this.game.add.text(1030, 10, "", "");
        Gameplay.setupText(this.infoText, false);
        this.infoTextWave = this.game.add.text(512, 300, "", "");
        this.infoTextWave.anchor.set(0.5, 0.5);
        Gameplay.setupText(this.infoTextWave, false);
        this.nextWaveButton = this.game.add.button(1030, 660, "button");
        this.buttonGroup.add(this.nextWaveButton);
        this.nextWaveButton.addChild(this.game.add.text(10, 10, "(n)ew wave now!", {
            font: "18px Arial",
            fill: "#FFFFFF",
            align: "center"
        }));
        this.nextWaveButton.onInputUp.add(this.triggerNextWave, this);
        this.resetButton = this.game.add.button(512, 500, "button");
        this.buttonGroup.add(this.resetButton);
        var text = this.game.add.text(0, 0, "i want to try again!", {
            font: "16px Arial",
            fill: "#FFFFFF",
            align: "center"
        });
        text.anchor.set(0.5, 0.5);
        this.resetButton.addChild(text);
        this.resetButton.scale.set(2.5, 2.5);
        this.resetButton.onInputUp.add(this.reset, this);
        this.resetButton.anchor.set(0.5, 0.5);
        this.resetButton.visible = false;
        this.rangeIndicator = this.game.add.sprite(0, 0, "range");
        this.rangeIndicator.visible = false;
        this.rangeIndicator.anchor.set(0.5, 0.5);
        this.buildTowerSprite = this.game.add.sprite(0, 0, "tower");
        this.buildTowerSprite.anchor.set(0.5, 0.5);
        this.buildTowerSprite.alpha = 0.7;
        this.buildTower = false;
        var range = this.game.add.sprite(0, 0, "range");
        range.anchor.set(0.5, 0.5);
        range.scale.set(1 / 250 * Gameplay.minTowerRange, 1 / 250 * Gameplay.minTowerRange);
        this.buildTowerSprite.addChild(range);
        this.buildTowerSprite.visible = false;
        this.buildTowerButton = this.game.add.button(1030, 700, "button");
        this.buttonGroup.add(this.buildTowerButton);
        this.buildTowerButton.onInputUp.add(function () {
            this.buildTower = !this.buildTower;
            if (this.buildTower) {
                this.selectedTower(null);
            }
        }, this);
        var text = this.game.add.text(40, 10, "(b)uild 25 $", { font: "18px Arial", fill: "#FFFFFF", align: "left" });
        this.buildTowerButton.addChild(text);
        var sprite = this.game.add.sprite(5, -5, "tower");
        this.buildTowerButton.addChild(sprite);
        sprite.scale.set(0.6, 0.6);
        this.upgradeTowerButtonDamage = this.game.add.button(1030, 400, "button");
        this.buttonGroup.add(this.upgradeTowerButtonDamage);
        this.upgradeTowerButtonDamage.onInputUp.add(this.upgradeDamage, this);
        var text = this.game.add.text(10, 10, "", { font: "14px Arial", fill: "#FFFFFF", align: "left" });
        this.upgradeTowerButtonDamage.addChild(text);
        this.upgradeTowerButtonRange = this.game.add.button(1030, 440, "button");
        this.buttonGroup.add(this.upgradeTowerButtonRange);
        this.upgradeTowerButtonRange.onInputUp.add(this.upgradeRange, this);
        var text = this.game.add.text(10, 10, "", { font: "14px Arial", fill: "#FFFFFF", align: "left" });
        this.upgradeTowerButtonRange.addChild(text);
        this.upgradeTowerButtonSpeed = this.game.add.button(1030, 480, "button");
        this.buttonGroup.add(this.upgradeTowerButtonSpeed);
        this.upgradeTowerButtonSpeed.onInputUp.add(this.upgradeSpeed, this);
        var text = this.game.add.text(10, 10, "", { font: "14px Arial", fill: "#FFFFFF", align: "left" });
        this.upgradeTowerButtonSpeed.addChild(text);
        this.upgradeTowerButtonReload = this.game.add.button(1030, 520, "button");
        this.buttonGroup.add(this.upgradeTowerButtonReload);
        this.upgradeTowerButtonReload.onInputUp.add(this.upgradeReload, this);
        var text = this.game.add.text(10, 10, "", { font: "14px Arial", fill: "#FFFFFF", align: "left" });
        this.upgradeTowerButtonReload.addChild(text);
        this.waveInfo = this.game.add.text(1030, 100, "", "");
        Gameplay.setupText(this.waveInfo, false);
        this.waveInfo.fontSize = 16;
        this.towerInfo = this.game.add.text(1030, 200, "", "");
        Gameplay.setupText(this.towerInfo, false);
        this.towerInfo.fontSize = 16;
        this.selectTower(null);
    };
    Gameplay.moneyFromLevel = function (lvl) {
        return Math.round(10 * Math.pow(1.4, lvl));
    };
    Gameplay.prototype.upgradeDamage = function () {
        if (this.selectedTower != null && this.money >= Gameplay.moneyFromLevel(this.selectedTower.lvlDamage)) {
            this.money -= Gameplay.moneyFromLevel(this.selectedTower.lvlDamage);
            this.selectedTower.increaseDamage();
            this.selectTower(this.selectedTower);
        }
    };
    Gameplay.prototype.upgradeReload = function () {
        if (this.selectedTower != null && this.money >= Gameplay.moneyFromLevel(this.selectedTower.lvlReload)) {
            this.money -= Gameplay.moneyFromLevel(this.selectedTower.lvlReload);
            this.selectedTower.increaseReload();
            this.selectTower(this.selectedTower);
        }
    };
    Gameplay.prototype.upgradeSpeed = function () {
        if (this.selectedTower != null && this.money >= Gameplay.moneyFromLevel(this.selectedTower.lvlSpeed)) {
            this.money -= Gameplay.moneyFromLevel(this.selectedTower.lvlSpeed);
            this.selectedTower.increaseSpeed();
            this.selectTower(this.selectedTower);
        }
    };
    Gameplay.prototype.upgradeRange = function () {
        if (this.selectedTower != null && this.money >= Gameplay.moneyFromLevel(this.selectedTower.lvlRange)) {
            this.money -= Gameplay.moneyFromLevel(this.selectedTower.lvlRange);
            this.selectedTower.increaseRange();
            this.selectTower(this.selectedTower);
        }
    };
    Gameplay.prototype.triggerNextWave = function () {
        if (this.nextWave > this.game.time.now) {
            this.nextWave = this.nextWave = this.game.time.now;
            this.nextWaveButton.visible = false;
        }
    };
    Gameplay.prototype.addText = function (text, add) {
        var lineBreak = "";
        if (text != "") {
            lineBreak = "\n";
        }
        return text + lineBreak + add;
    };
    Gameplay.prototype.updateInfoText = function () {
        var text = "";
        if (this.displayMoney < this.money) {
            this.displayMoney += 1;
        }
        if (this.displayMoney > this.money) {
            this.displayMoney -= 1;
        }
        if (this.level > 0) {
            text = this.addText(text, "wave: " + this.level);
        }
        else {
            text = this.addText(text, "wave: -");
        }
        text = this.addText(text, this.displayMoney + " $");
        if (this.infoText.text != text) {
            this.infoText.text = text;
        }
        if (this.nextWave != -1) {
            this.infoTextWave.text = "next wave in " + Math.round((this.nextWave - this.game.time.now) / 1000) + " seconds";
        }
        else {
            this.infoTextWave.text = "";
        }
    };
    Gameplay.prototype.selectTower = function (tower) {
        if (this.selectedTower != null) {
            this.selectedTower.children[1].tint = 0xFFFFFF;
        }
        if (tower != null) {
            tower.children[1].tint = 0xFF00FF;
            this.rangeIndicator.visible = true;
            this.rangeIndicator.x = tower.x;
            this.rangeIndicator.y = tower.y;
            this.rangeIndicator.scale.x = 1 / 250 * tower.range;
            this.rangeIndicator.scale.y = 1 / 250 * tower.range;
            this.towerInfo.text = tower.getInfoText();
            this.upgradeTowerButtonDamage.visible = tower.lvlDamage < 10;
            this.upgradeTowerButtonDamage.children[0].text = "+ (d)amage " + Gameplay.moneyFromLevel(tower.lvlDamage) + " $";
            this.upgradeTowerButtonRange.visible = tower.lvlRange < 10;
            this.upgradeTowerButtonRange.children[0].text = "+ attack (r)ange " + Gameplay.moneyFromLevel(tower.lvlRange) + " $";
            this.upgradeTowerButtonReload.visible = tower.lvlReload < 10;
            this.upgradeTowerButtonReload.children[0].text = "+ (f)aster reload " + Gameplay.moneyFromLevel(tower.lvlReload) + " $";
            this.upgradeTowerButtonSpeed.visible = tower.lvlSpeed < 10;
            this.upgradeTowerButtonSpeed.children[0].text = "+ fireball (s)peed " + Gameplay.moneyFromLevel(tower.lvlSpeed) + " $";
        }
        else {
            this.upgradeTowerButtonDamage.visible = false;
            this.upgradeTowerButtonRange.visible = false;
            this.upgradeTowerButtonReload.visible = false;
            this.upgradeTowerButtonSpeed.visible = false;
            this.rangeIndicator.visible = false;
            this.towerInfo.text = "";
        }
        this.selectedTower = tower;
    };
    Gameplay.prototype.isStreet = function (x, y) {
        return (x >= 211 && y >= 90 && x <= 1024 && y <= 164) || (x >= 211 && y >= 90 && x <= 280 && y <= 511) || (x >= 280 && y >= 447 && x <= 850 && y <= 511) || (x >= 789 && y >= 447 && x <= 850 && y <= 738) || (x >= 80 && y >= 660 && x <= 789 && y <= 738);
    };
    Gameplay.prototype.update = function () {
        if (this.level == 999) {
            return;
        }
        this.updateInfoText();
        if (this.lifes <= 0) {
            return;
        }
        if (this.game.input.activePointer.isDown && this.game.input.mouse.button == 2) {
            this.buildTower = false;
            this.selectTower(null);
        }
        if (this.game.input.keyboard.isDown(Phaser.Keyboard.B)) {
            this.buildTower = true;
            this.selectTower(null);
        }
        if (this.game.input.keyboard.isDown(Phaser.Keyboard.N)) {
            if (this.nextWaveButton.visible) {
                this.triggerNextWave();
            }
        }
        if (!this.game.input.keyboard.isDown(Phaser.Keyboard.D) && !this.game.input.keyboard.isDown(Phaser.Keyboard.R) && !this.game.input.keyboard.isDown(Phaser.Keyboard.F) && !this.game.input.keyboard.isDown(Phaser.Keyboard.S)) {
            this.keyWasUp = true;
        }
        if (this.keyWasUp && this.game.input.keyboard.isDown(Phaser.Keyboard.D)) {
            if (this.upgradeTowerButtonDamage.visible) {
                this.upgradeDamage();
                this.keyWasUp = false;
            }
        }
        if (this.keyWasUp && this.game.input.keyboard.isDown(Phaser.Keyboard.R)) {
            if (this.upgradeTowerButtonRange.visible) {
                this.upgradeRange();
                this.keyWasUp = false;
            }
        }
        if (this.keyWasUp && this.game.input.keyboard.isDown(Phaser.Keyboard.F)) {
            if (this.upgradeTowerButtonReload.visible) {
                this.upgradeReload();
                this.keyWasUp = false;
            }
        }
        if (this.keyWasUp && this.game.input.keyboard.isDown(Phaser.Keyboard.S)) {
            if (this.upgradeTowerButtonSpeed.visible) {
                this.upgradeSpeed();
                this.keyWasUp = false;
            }
        }
        if (this.game.time.now - this.lastSpawnTime > 1000 && this.levelCreepCount < Gameplay.minCreepCount + (Gameplay.creepCountFactor * this.level)) {
            var creep = new Creep(this, 1050, 129, 0, Math.round(10 * Math.pow(1.6, this.level - 1)));
            this.waveInfo.text = "Mob HP: " + creep.health;
            this.levelCreepCount++;
            this.lastSpawnTime = this.game.time.now;
        }
        if (this.nextWave != -1 && this.nextWave - this.game.time.now < 0) {
            this.level++;
            this.levelCreepCount = 0;
            this.nextWave = -1;
            this.nextWaveButton.visible = false;
        }
        if (this.nextWave == -1 && this.levelCreepCount == Gameplay.minCreepCount + (Gameplay.creepCountFactor * this.level) && this.creepGroup.getFirstAlive() == null) {
            this.nextWave = this.game.time.now + 1000 * 30;
            this.nextWaveButton.visible = true;
        }
        //keine tower auf buttons stellen
        if (this.game.input.activePointer.isDown && this.wasUp) {
            for (var i = 0; i < this.buttonGroup.children.length; i++) {
                if (this.buttonGroup.children[i].visible) {
                    if (this.game.input.hitTest(this.buttonGroup.children[i], this.game.input.activePointer, new Phaser.Point())) {
                        this.wasUp = false;
                        break;
                    }
                }
            }
        }
        //nix rechts im info bereich erstellen
        var x = this.game.input.activePointer.x;
        var y = this.game.input.activePointer.y;
        if (x > 1024) {
            if (this.game.input.activePointer.isDown && this.wasUp) {
                this.buildTower = false;
                this.selectTower(null);
            }
            this.wasUp = false;
        }
        //nicht auf der strasse bauen
        if (this.buildTower) {
            if (this.isStreet(x, y + 20) || this.isStreet(x, y + 20) || this.isStreet(x + 15, y) || this.isStreet(x - 20, y)) {
                this.wasUp = false;
            }
        }
        for (var i = 0; i < this.towerGroup.children.length; i++) {
            var tower = this.towerGroup.children[i];
            if (this.game.input.hitTest(tower, this.game.input.activePointer, new Phaser.Point())) {
                if (this.game.input.activePointer.isDown && this.wasUp) {
                    this.selectTower(tower);
                    this.wasUp = false;
                    break;
                }
            }
        }
        if (this.buildTower) {
            this.buildTowerSprite.visible = true;
            this.buildTowerSprite.x = x;
            this.buildTowerSprite.y = y;
        }
        else {
            this.buildTowerSprite.visible = false;
        }
        if (this.game.input.activePointer.isDown && this.wasUp) {
            if (this.buildTower) {
                if (this.money >= 25) {
                    this.money -= 25;
                    var tower = new Tower(this, x, y);
                    this.towerGroup.sort("y", Phaser.Group.SORT_ASCENDING);
                    this.selectTower(tower);
                    this.buildTower = false;
                }
                else {
                }
            }
            else {
                this.selectTower(null);
            }
            this.wasUp = false;
        }
        if (!this.game.input.activePointer.isDown) {
            this.wasUp = true;
        }
        this.game.physics.arcade.overlap(this.bulletGroup, this.creepGroup, this.hit, null, this);
    };
    Gameplay.prototype.hit = function (bullet, creep) {
        if (bullet.alive && creep.alive) {
            bullet.kill();
            creep.damage(bullet.damageValue);
            if (!creep.alive) {
                this.money += Math.round(Math.pow(1.5, this.level - 1)) * 2;
            }
        }
    };
    Gameplay.prototype.loseLife = function () {
        this.lifes--;
        this.deathOverlay.alpha = Math.min(1, 1 - this.lifes / 10);
        if (this.lifes == 0) {
            this.deathText.visible = true;
            this.resetButton.visible = true;
            this.logScore();
        }
    };
    Gameplay.prototype.reset = function () {
        this.money = 50;
        this.displayMoney = 50;
        this.nextWave = this.game.time.now + 1000 * 15;
        this.levelCreepCount = Gameplay.minCreepCount;
        this.lastSpawnTime = 0;
        this.level = 0;
        this.lifes = 10;
        this.deathOverlay.alpha = 0;
        this.deathText.visible = false;
        this.nextWaveButton.visible = true;
        this.resetButton.visible = false;
        this.selectTower(null);
        for (var i = this.creepGroup.children.length - 1; i >= 0; i--) {
            this.creepGroup.children[i].destroy();
        }
        for (var i = this.winnerGroup.children.length - 1; i >= 0; i--) {
            this.winnerGroup.children[i].destroy();
        }
        for (var i = this.towerGroup.children.length - 1; i >= 0; i--) {
            this.towerGroup.children[i].destroy();
        }
        for (var i = this.bulletGroup.children.length - 1; i >= 0; i--) {
            this.bulletGroup.children[i].destroy();
        }
    };
    Gameplay.prototype.logScore = function () {
        $.ajax({
            type: "GET",
            url: "/log.php",
            data: { gameid: 4, score: this.money, level: this.level, date: new Date }
        });
    };
    Gameplay.minTowerRange = 100;
    Gameplay.minCreepCount = 11;
    Gameplay.creepCountFactor = 2; //level * faktor creeps
    return Gameplay;
})(Phaser.State);
//# sourceMappingURL=gameplay.js.map